String currentStore = "rootStore";

final Map<String, Map<String, dynamic>> store = {currentStore: {}};

void useStore(String storeName) {
  currentStore = storeName;
  if (!store.containsKey(currentStore)) store[currentStore] = {};
}

void saveToStore(String key, value) => store[currentStore][key] = value;

void saveToStoreMultiple(Map<String, dynamic> pairs) {
  pairs.forEach((key, value) {
    saveToStore(key, value);
  });
}

Map<String, dynamic> serveStore([String storeName]) {
  storeName ??= currentStore;
  return store[storeName];
}

// Deletes current store or specified store
Map<String, dynamic> removeStore([String storeName]) {
  storeName ??= currentStore;
  final Map<String, dynamic> r = store.remove(currentStore);
  useStore("rootStore");
  return r;
}

getFromStore(String key) => store[currentStore][key];

void logStore([String storeName]) {
  storeName ??= currentStore;
  print(store[storeName]);
}

void logCompleteStore() => print(store);
